/**
 * Obtiene la ruta hacia una IP
 * @author David Gmez Jimnez
 * @version 2010-12-26
 */

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.security.AccessController;
import java.security.PrivilegedAction;
import java.util.ArrayList;

public class Route implements PrivilegedAction{

	String direccion = new String();
	String SO = new String();
	
	public Route(String address, String SO) {
	      this.direccion = address;
	      this.SO = SO;
	}
	
	/**
	 * Mtodo que ejecuta el proceso
	 * Se van haciendo pings con caducidad TTL para ver que IP responde en cada paso
	 */
	public String run() {
		Integer ttl = 0;		
		Process p = null;
		String respDestino = new String();
		String coincidencia = new String();				
		ArrayList<String> lista = new ArrayList<String>();
		String ipDesti = (String) AccessController.doPrivileged(new Translation(direccion));
		String respFinal = new String();
		String respMedia = new String();
		String comando = new String();
		String cadenaInicio = new String();
		String cadenaFin = new String();
		if (SO.contains("W")){
			respFinal = "Respuesta desde " + ipDesti;
			respMedia = "Respuesta desde";
			comando = "cmd /C ping -n 1 " + ipDesti.toString() + " -i ";
			cadenaInicio = ":";
			cadenaFin = " "; 
		}
		else
		{
			respFinal = "from " + ipDesti;
			respMedia = "From";
			comando = "ping -n -c 1 " + ipDesti.toString() + " -t ";
		}
		
		while (!coincidencia.contains(respFinal))
		{
			ttl = ttl + 1;
	        try 
	        {  
	            p = Runtime.getRuntime().exec(comando + ttl.toString());  //Ejecutamos el ping 
	            BufferedReader in = new BufferedReader(new InputStreamReader(p.getInputStream()));  
	            String line = null;  
	            while ((line = in.readLine()) != null) 
	            {  
	                if ((line.contains(respMedia))||(line.contains(respFinal)))	//Extraemos la IP que nos ha respondido en este paso
	                {
	                	respDestino = line.toString();
	                	coincidencia = line.toString();
	                	
	                	//Adaptamos la cadena de Linux para extraer IP
	                	if(respDestino.contains(" icmp_seq")){
	                		respDestino = respDestino.replace(" icmp_seq", ":");
	                	}
	                	
	                	if(respDestino.contains(" bytes ")){
	                		respDestino = respDestino.replace(" bytes ", " ");
	                	}
	                	
	                	if(respDestino.contains("From")){
	                		respDestino = respDestino.replace("From", " From");
	                	}
	                	
	                	//Extraer direccin IP
	                	int pos = respDestino.indexOf(":");
	                	respDestino = respDestino.substring(0,pos);
	                	pos = respDestino.indexOf(" ");
	                	respDestino = respDestino.substring(pos+1,respDestino.length());
	                	pos = respDestino.indexOf(" ");
	                	respDestino = respDestino.substring(pos+1,respDestino.length());
	                	lista.add(respDestino);
	                }
	            }
	        }
	        catch (IOException e) 
	        {  
	            e.printStackTrace();  
	        }
		}
		System.out.print(lista.toString());
		return lista.toString();
	}
}
