<?php
/*
<!--
Project: Traceworld
Author: David Gmez Jimnez
File: whois.php
Version: 2010-12-26
Description: Muestra datos de whois de la IP
Recibe: $_POST['query']
-->
 */

header('Content-Type: text/html; charset=UTF-8');

//Cabecera HTML
$out =  implode('', file('mapaWhois.html'));

//Extraer bloque de datos
$resout = extract_block($out, 'results');

//Varieble query contenido: IP destino
if (isSet($_POST['query']))
	{
	$query = $_POST['query'];
		
	//includes para consulta whois
	include_once('./phpwhois/whois.main.php');
	include_once('./phpwhois/whois.utils.php');
	
	//Creacion objeto whois
	$whois = new Whois();
	
	// Set to true if you want to allow proxy requests
	$allowproxy = false;
	
	//Ejecutamos consulta
	$result = $whois->Lookup($query);
	
	//Substituimos en el HTML con el contenido del whois 
	$resout = str_replace('{query}', $query, $resout);
	
	//Segun el formato de salida, obtenemos salida de texto adecuada con showXXXX
	$winfo = '';

	switch ($output)
		{
		case 'object':
			if ($whois->Query['status'] < 0)
				{
				$winfo = implode($whois->Query['errstr'],"\n<br></br>");
				}
			else
				{
				$utils = new utils;
				$winfo = $utils->showObject($result);
				}
			break;
			
		case 'nice':			
			if (!empty($result['rawdata']))
				{
				$utils = new utils;
				$winfo = $utils->showHTML($result);
				}
			else
				{
				if (isset($whois->Query['errstr']))
					$winfo = implode($whois->Query['errstr'],"\n<br></br>");
				else
					$winfo = 'Unexpected error';
				}       
			break;

		case 'proxy':
			if ($allowproxy)
				exit(serialize($result));
			
		default:
			if(!empty($result['rawdata']))
				{
				$winfo .= '<pre>'.implode($result['rawdata'],"\n").'</pre>';
				}
			else
				{
				$winfo = implode($whois->Query['errstr'],"\n<br></br>");
				}       
		}
	
	//$winfo = utf8_encode($winfo);
	
	//Substituimos en el HTML con el resultado del whois
	$resout = str_replace('{result}', $winfo, $resout);
	}
else
	$resout = '';

//Mostramos los resultados por pantalla	
echo str_replace('{results}', $resout, $out);

//-------------------------------------------------------------------------

function extract_block (&$plantilla,$mark,$retmark='')
{
$start = strpos($plantilla,'<!--'.$mark.'-->');
$final = strpos($plantilla,'<!--/'.$mark.'-->');

if ($start === false || $final === false) return;

$ini = $start+7+strlen($mark);

$ret=substr($plantilla,$ini,$final-$ini);

$final+=8+strlen($mark);

if ($retmark===false)
	$plantilla=substr($plantilla,0,$start).substr($plantilla,$final);
else	
	{
	if ($retmark=='') $retmark=$mark;
	$plantilla=substr($plantilla,0,$start).'{'.$retmark.'}'.substr($plantilla,$final);
	}
	
return $ret;
}
?>